/* rainbow.h -- rainbow visualization plugin for xmms 
   Written by Bryan Rittmeyer <bryanr@caltech.edu>
   Copyright (C) 1999 Horizon Technologies
   http://horizon.pair.com/                          */


#ifndef _RAINBOW_H
#define _RAINBOW_H

/* Includes */
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <gtk/gtk.h>
#include <time.h>
#include "GL/glx.h"
#include "GL/glu.h"
#include "GL/gl.h"
#ifdef HAVE_XMESAFINDBUFFER
#include <GL/xmesa.h>
#endif
#include "pthread.h"
#ifdef HAVE_SCHED_SETSCHEDULER
#include "sched.h"
#endif
#include "xmms/plugin.h"
#include "xmms/xmmsctrl.h"
#include "xmms/configfile.h"
#include "xmms/util.h"
#include "plugcfg.h"

/* defines */
#define bLEFT -0.7f
#define bTOP -0.5f
#define bWIDTH 1.4f
#define bHEIGHT 1.0f
#define ZFACTOR (ftotal * 2.0f * i)
#define TRANSPARENCY 0.5f + (ftotal * 2.0f)
#define DRAWFRAME 100

/* function prototypes */
static Window create_window(int width, int height);
void *draw_thread_func(void *arg);
static void start_display(void);
static void stop_display(void);
static gint disable_func(gpointer data);
void create_rainbow(void);
static void draw_rainbow(void);

/* Globals */
static float CameraTrans[16], ObjectTrans[16], Rotation, Max;
static int ClientW=640, ClientH=480;
static int direction;
static unsigned int colourSwap = 0;
static int x, y;
static float i;
static float ftotal;
static gboolean newframe = FALSE;

PluginConfig plugin_cfg;

/* stolen from opengl_spectrum */
static Display *dpy = NULL;
static Colormap colormap = 0;
static GLXContext glxcontext = NULL;
static Window window = 0;
static gboolean going = FALSE,grabbed_pointer=FALSE;
static Atom wm_delete_window_atom;
static pthread_t draw_thread;

static GtkWidget *dialog, *button, *label;

#endif
