/*
 * Water ripples
 *
 * This stuff uses way too many statics and void functions. As with particle.c,
 * I don't usually code like this :) This is mainly cos I've got ~1 day to do
 * this, and can't be fucked coding well. Oh well.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <vga.h>
#include <time.h>
#include <string.h>
#include "utility.h"
#include "am_alloc.h"
#include "ripple.h"

static char *SineTable[MAXRADIUS];
static char *WaveTable[MAXRADIUS];
static amObject *RippObj;
static Ripple *RippList;
static char RippAlpha[HEIGHT][WIDTH];

/* Background generation and final drawing */
static char ZeroChar[]={ 20,20,20,20,20,
                         20,30,42,30,20,
                         20,42,30,42,20,
                         20,42,20,42,20,
                         20,42,20,42,20,
                         20,42,30,42,20,
                         20,30,42,30,20,
                         20,20,20,20,20 };
static char OneChar[]= { 30,40,40,40,30,
                         40,40,20,40,40, 
                         40,20,20,40,40, 
                         40,40,20,40,40, 
                         40,40,20,40,40, 
                         40,40,20,40,40, 
                         40,20,20,20,40,
                         30,40,40,40,30 };
static unsigned char Background[HEIGHT * WIDTH];

int main(int argc, char *argv[]) {
	short i = 0;
	long framerate = 50000;
	short rain = 0, wfreq = 15, bfreq = 8, mode = THREED;
	clock_t start;

	srand(clock());

	setVerbose(0); /* Note that verbosity is only for debugging purposes here */
	setRuntimeName(argv[0]);
	
	for(i = 1; i < argc; i++) {
		if(!strcmp(argv[i], "-h")) {
			printf("\nAlcaron's Water Fx Comp Entry!\n\n");
			printf("Options:\n");
			printf("-r: Steady rain rather than random waves\n");
			printf("-f##: Framerate in frames per second\n");
			printf("-w##: Wave generation frequency. Higher number means less"
			       " waves\n");
			printf("-b##: Background generation frequency. As above.\n");
			printf("(Note that ## denotes a number)\n");
			printf("\nModes:\n");
			printf("-m: Multiply\n");
			printf("-3d: ThreeD (default)\n");
			printf("-a: Additive\n");
			return 0;
		} else if(!strcmp(argv[i], "-r")) {
			rain = 1;
			wfreq = 5;
		} else if(!strncmp(argv[i], "-f", 2)) {
			framerate = atol(argv[i] + 2);
		} else if(!strncmp(argv[i], "-w", 2)) {
			wfreq = atoi(argv[i] + 2);
		} else if(!strncmp(argv[i], "-b", 2)) {
			bfreq = atoi(argv[i] + 2);
		} else if(!strcmp(argv[i], "-m")) {
			mode = FADE;
		} else if(!strcmp(argv[i], "-3d")) {
			mode = THREED;
		} else if(!strcmp(argv[i], "-a")) {
			mode = ALPHA;
		}
	}
	
	printf("Creating ripple wave lookup table... \n");
	GenInitialSineTable();

	verbose("Generating smaller copies of initial table.");
	for(i = 1; i < MAXRADIUS; i++) {
		GenCopySineTable(i);
	}

	printf("Generating circle lookup table... \n");
	GenWaveTable();

	printf("Intialising VGA... \n");
	SetupVga();
	SetGrayscalePalette();
	
	GenRippList();
	while(!vga_getkey()) {
		if(i>bfreq)
			i = 0;
		if((int)RAND(wfreq) == 1) {
			if(rain) {
				GenRipple((short) RAND(WIDTH), (short) RAND(HEIGHT), 40);
			} else {
				GenRipple((short) RAND(WIDTH), (short) RAND(HEIGHT), RAND(128));
			}
		}	

		start = clock();
		RippleIteration();
		if(!i)
			GenerateBackground();
		switch(mode) {
			case THREED:
				ThreeDFrame();
				break;
			case FADE:
				FadeFrame();
				break;
			case ALPHA:
				AlphaFrame();
		}
		while(clock() - start < framerate);
		i++;
	}

	return 0;
}

void SetupVga(void) {
	if(vga_init()) 
		fatalError(1, "VGA initialisation failed.");
	
	atexit(DisableVga);
	
	verbose("Setting VGA mode of " DEFMODESTRING ".");
	
	if(vga_setmode(DEFMODE))
		fatalError(1, "Cannot set VGA mode to " DEFMODESTRING ".");
	
	/* Echo the palette to the page wossname */
	
}

void DisableVga(void) {
	verbose("Setting text mode.");
	vga_setmode(TEXT);
	printf("\nSource is available on request, DOS port is coming soon.\n\n");
	printf("Michael Pearson <alcaron@ozemail.com.au> 1999.\n");
}

void SetGrayscalePalette(void) {
	int index;
	verbose("Setting grayscale palette.");
	for(index = 0; index < 64; index++)
		vga_setpalette(index, 0, 0, index);
}

void GenInitialSineTable(void) {
	char *new, *cptr;
	unsigned char width, height, i;
	int currpos, frame;

	verbose("Generating initial sine table");
	
	new = safeMalloc(sizeof(char) * MAXRADIUS * MAXRADIUS * 2);
	cptr = new;
	for(frame = MAXRADIUS*2; frame > 0; frame--) {
		currpos = frame - 128;

		/* Put pre-wave filler */
		for(i = 0; i < currpos-1; i++) {
			*cptr++ = 0;
		}
		for(width = MAXRADIUS/2; width > 0; width /= 2) {
			/* Calc height of current wave */
			if(currpos > 0)
				height = width * (float) (currpos + 1) / MAXRADIUS /2;
			else
				height =0;

			/* Generate positive wave */
			for(i = 0; i < width/2 && currpos <= MAXRADIUS; i++) {
				if(currpos >= 0)
					*cptr++ = (char) height * sin((float) i/width * 2*PI);
				currpos++;
			}

			/* Generate negative wave */
			for(i = 0; i < width/2 && currpos <= MAXRADIUS; i++) {
				if(currpos >= 0)
					*cptr++ = (char) -(height) * sin((float) i/width * 2*PI);
				currpos++;
			}
			if(currpos > MAXRADIUS)
				break; /* Don't calculate stuff when we don't need to */
		}

		/* Put post-wave filler */
		for(i = currpos; i < MAXRADIUS; i++) {
			*cptr++ = 0;
		}
	}
	SineTable[MAXRADIUS] = new;
}
		
void GenCopySineTable(int sineno) {
	char *new, *cptr;
	int frame, pos;

	new = safeMalloc(sizeof(char) * sineno * sineno * 2);
	cptr = new;
	for(frame = 0; frame < sineno*2; frame++)
		for(pos = 0; pos < sineno; pos++)
			*cptr++ = *(SineTable[MAXRADIUS] + frame * (MAXRADIUS / sineno)
			        * MAXRADIUS + pos * (MAXRADIUS / sineno)) 
			        * ((float) sineno/MAXRADIUS);
	
	SineTable[sineno] = new;
}
			
void GenWaveTable(void) {
	char *new, *cptr, oldx, oldy, currx, curry;
	size_t size = 0;
	int radius, tmpradius;
	double radian;
	
	/* This is extremely inefficient, but I CBF working out anything else */
	
	/* Find size of circletable */
	for(radius = MAXRADIUS; radius > 0; radius--) {
		oldy = 0;
		oldx = 0;
		for(radian = 0; radian < 2*PI; radian += PI/512) {
			currx = sin(radian) * radius;
			curry = cos(radian) * radius;
			if(oldx != currx || oldy != curry) {
				size++;	
				oldx = currx;
				oldy = curry;
			}
		}
		size++;
	}


	/* Create new table */
	new = safeMalloc(size * 2);
	for(radius = MAXRADIUS; radius > 0; radius--) {
		WaveTable[radius] = new;
		oldy = 0;
		oldx = 0;
		for(radian = 0; radian < 2*PI; radian += PI/512) {
			currx = sin(radian) * radius;
			curry = cos(radian) * radius;
			if(radius == MAXRADIUS)
				tmpradius = MAXRADIUS;
			else
				tmpradius = radius+1;	
			for(cptr = WaveTable[tmpradius]; cptr < new; cptr += 2)
				if(*cptr == currx && *(cptr + 1) == curry)
					break;
			if(cptr >= new - 1 ) {
				*new++ = currx;
				*new++ = curry;
			}
		}
		*new++ = 0;
		*new++ = 0;
	}
}

void GenRippList(void) {

	RippObj = amNewObject(sizeof(Ripple), 40);
	
	RippList = amAlloc(RippObj);	
	/* Note that because this is the root node, we shouldn't need to init
	   anything except next, but we will for debugging purposes */
	RippList->posx = 0;
	RippList->posy = 0;
	RippList->radius = 0;	
	RippList->sinepos = NULL;
	RippList->frameno = 0;
	RippList->previous = NULL;
	RippList->next = NULL;

	/* Also, null out the RippAlpha table */
	memset(&RippAlpha[0][0], 0, 64000);
}

inline void AddRippNode(Ripple *node) {
	node->next = RippList->next;
	node->previous = RippList;
	RippList->next = node;
	if(node->next)
		node->next->previous = node;
}
	
inline void KillRippNode(Ripple *node) {
	node->previous->next = node->next;
	if(node->next)
		node->next->previous = node->previous;
	amFree(RippObj, (struct am_chunk *) node);
}

void GenRipple(short x, short y, unsigned char radius) {
	Ripple *new;

	new = amAlloc(RippObj);
	new->posx = x;
	new->posy = y;
	new->radius = radius;	
	new->sinepos = SineTable[radius];
	new->frameno = radius * 2;
	AddRippNode(new);
}
	
void DrawRipple(Ripple *node) {
	short ourx, oury, currad, final;
	char *cptr, *dest;

	cptr=WaveTable[node->radius];
	for(currad = node->radius; currad > 0; currad--) {
		while(!(*cptr == 0 && *(cptr + 1) == 0)) {	
			ourx = *cptr++ + node->posx;
			oury = *cptr++ + node->posy;
			if(ourx >= 0 && ourx < WIDTH && oury >= 0 && oury < HEIGHT) {
				dest = &RippAlpha[oury][ourx];
				final = (int) *dest + *(node->sinepos);
				if(final > 127) 
					*dest = 127; 
				else if(final < -127)
					*dest = -127;
				else
					*dest = (char) final;
			}
		}
		node->sinepos += 1;
		cptr +=2;
	}
}

void RippleIteration(void) {
	Ripple *node, *next;
	
	memset(&RippAlpha[0][0], 0, 64000);

	for(node = RippList->next; node; node = next) {
		DrawRipple(node);
		node->frameno--;
		next = node->next;
		if(!node->frameno)
			KillRippNode(node);
	}
}
			
void GenerateBackground(void) {
	unsigned char *cptr, *dptr;
	short x, y, y2, x2;
	
	cptr = Background;
	for(y = 0; y < 200; y += 8) {
		for(x = 0; x < 320; x += 5) {
			if((int)RAND(2))
				dptr = OneChar;
			else
				dptr = ZeroChar;
			for(y2 = 0; y2 < 8; y2++) {
				for(x2 = 0; x2 < 5; x2++)
					*cptr++ = *dptr++;
				cptr += WIDTH - 5;
			}
			cptr -= WIDTH * 8 - 5;
		}
		cptr += WIDTH * 7;
	}
}

void AlphaFrame(void) {
	char *aptr;
	unsigned char *gptr, *bptr;
	short final;
	unsigned short i;

	aptr = &RippAlpha[0][0];
	gptr = graph_mem;
	bptr = Background;
	
	for(i=0; i < 64000; i++) {
		final = *bptr++ + *aptr++;	
		if(final < 0)
			final = 0;
		else if(final > 63)
			final = 63;

		*gptr++ = (unsigned char) final;
		
	}
}

void FadeFrame(void) {
	char *aptr;
	unsigned char *gptr, *bptr;
	short final;
	unsigned short i;

	aptr = &RippAlpha[0][0];
	gptr = graph_mem;
	bptr = Background;
	
	for(i=0; i < 64000; i++) {
		final = *aptr * 2;
		if(final < 0)
			final = 0;
		else if(final < 63)
			final = (short) ((float) *bptr * final / 63);
		else 
			final = *bptr;

		aptr++;
		bptr++;
		*gptr++ = (unsigned char) final;
		
	}
}

void ThreeDFrame(void) {
	char *aptr;
	unsigned char *gptr, *bptr, *fptr;
	short final;
	unsigned short i;

	aptr = &RippAlpha[0][0];
	gptr = graph_mem;
	bptr = Background;
	
	for(i=0; i < 64000; i++) {
		fptr = bptr++ + *aptr * WIDTH;
		if(fptr < Background || fptr > Background + 64000)
			final = 0 + *aptr++; 
		else
			final = *fptr + *aptr++;

		
		if(final < 0)
			final = 0;
		else if(final > 63)
			final = 63;

		*gptr++ = (unsigned char) final;
		
	}
}
