/*
 * Miscellaneous utility functions
 *
 * Michael Pearson <alcaron@ozemail.com.au>
 * Student Number:	s0383042
 * Last Revision: 	11/03/99
 *
 * Known Bugs:		Zip.
 *
 */

/* Safe Memory Allocation */
void *safeMalloc(size_t size);
void *safeRealloc(void *block, size_t size);
char *safeStrdup(const char *s);
char *safeStrndup(const char *s, size_t size);

/* Quick'n'Dirty prompt and input functions */
char *getString(const char * format, ...);
double getDouble (const char *prompt);
int getInt (const char *prompt);

/* Option input */
char getOption(const char *prompt, const char *options);
int getYesNo(const char *prompt);

/* String manipulation */
void appendChar(char *dest, char src);
void strUpper(char *string);
void strLower(char *string);
void stripString(char *string);
char *ptrStrDup(char *start, char *end);

/* Verbose and RunTimeName should be set when the program starts. */
/* Hint... don't mess with the string that GetRunTimeName returns */
void setVerbose(int verbosity);
int getVerbose(void);
void setRuntimeName(const char *name);
const char *getRunTimeName(void);

/* Error handling, and messages */
void fatalError(int errorcode, const char *format, ...);
void warning(const char *format, ...);
void verbose(const char *format, ...);
