/*
 * Fixed-size stack allocation.
 *
 * All the function explanations are in this file, I'll leave the rest up to
 * you. I hate documentation. 
 *
 * Michael Pearson <alcaron@ozemail.com.au>
 *
 */

/* 
 * Everything is based around a main object. This is passed whenever the
 * program wants to malloc something or free something. It is initialised with
 * am_obdef_new(size_t size, int blocksize);.
 */
typedef struct am_obdef {
	size_t size;
	int blocksize;
	struct am_chunk * freestack;
	struct am_block * blockstack;
} amObject;

/* 
 * Nothing really interesting here. It's just a pointer to the next block in
 * the stack.
 */
typedef struct am_chunk {
    struct am_chunk * next;
} amChunk;

/* Or here. Internal block stuff */
typedef struct am_block {
	amChunk * begin;
	struct am_block * next;
} amBlock; 

/*
 * Make a new object with which we can alloc blocks. Blocksize*size is alloced
 * upon initialisation.
 */
amObject * amNewObject(size_t size, int blocksize);

/* 
 * Kill an object that we don't use anymore. This is what the blockstack is
 * for.
 */
void amKillObject(amObject * obj);

/*
 * Allocate a single chunk.
 */
void * amAlloc(amObject *obj);

/*
 * Free a single chunk.
 */
void amFree(amObject *obj, void *chunk);

/*
 * Create a new block and add it to the freestack and blockstack
 */
void amNewBlock(amObject *obj);

