/*
 * 
 *  XMMS Scope WindowMaker Dock Applet
 *  wmxmms_scope.so  v0.1
 *  
 *  Author:	Michael Pearson (alcaron@vurt.net) 2000
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *    
 *  You should have received a copy of the GNU General Public License
 *  along with this program (see the file COPYING); if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 *  Boston, MA  02111-1307, USA
 *
 *  This dockapp is actually just a munged version of Pontus Klang's 
 *  wmxmms_spectrum app. Kudos to him for providing the base for this :)
 *          
 */

#include <math.h>
#include <gtk/gtk.h>
#include <X11/xpm.h>

#include "wmgeneral.h"
#include "plugin.h"
#include "wmapp.xpm"

#define SCREEN_X	64
#define SCREEN_Y	64
#define DRAW_X		60	
#define DRAW_Y		22	

static char wmapp_mask_bits[64*64];
static int wmapp_mask_width = 64;
static int wmapp_mask_height = 64;
gint16 wave_height[DRAW_X];

float dscale;

static int doneflag = 0;

static void plug_init(void);
static void plug_cleanup(void);
static void plug_playback_start(void);
static void plug_playback_stop(void);
static void plug_render_pcm(gint16 data[2][512]);
static void plug_cleanup(void);

VisPlugin sanalyzer_vp =
{
	NULL,
	NULL,
	0,  
	"XMMS Scope dock applet",
	1,
	0,		
	plug_init,				/* init */
	plug_cleanup,			/* cleanup */
	NULL,					/* about */
	NULL,					/* configure */
	NULL,					/* disable_plugin */
	plug_playback_start, 	/* playback_start */
	plug_playback_stop, 	/* playback_stop */
	plug_render_pcm,		/* render_pcm */
	NULL  		/* render_freq */
};

VisPlugin *get_vplugin_info(void)
{
	return &sanalyzer_vp;
}

static void plug_init(void)
{
	char *fake[] = {"wmplug, wmplug"};
	createXBMfromXPM(wmapp_mask_bits, wmapp_xpm, wmapp_mask_width, wmapp_mask_height);
	openXwindow(1, fake, wmapp_xpm, wmapp_mask_bits, wmapp_mask_width, wmapp_mask_height);
	copyXPMArea(120,0,60,60-12,0,12);
	RedrawWindow();
	
	dscale = (SCREEN_Y-12)/log(256);		
}

static void plug_cleanup(void)
{
	XCloseDisplay(display);
	sanalyzer_vp.disable_plugin(&sanalyzer_vp);
}

void draw_wave(void) {
	int i;

	copyXPMArea(120,0,60,60-12,0,12);

	for(i = 0; i< DRAW_X; i++) {
		copyXPMArea(65, 40, 1, 1, i, wave_height[i]+1);
		copyXPMArea(65, 0, 1, 1, i, wave_height[i]);
	}
}

static gint draw_func(void)
{
	if (doneflag)
		return FALSE;

	GDK_THREADS_ENTER(); {
		doneflag = 1;
		/*draw_leds();*/
		draw_wave();
		RedrawWindow();
	}
	GDK_THREADS_LEAVE();

	doneflag = 0;
	return TRUE;
}

static void plug_playback_start(void)
{
	
}

static void plug_playback_stop(void)
{
	copyXPMArea(120,0,60,60-12,0,12);
	RedrawWindow();
}

static void plug_render_pcm(gint16 data[2][512]) {
	int i;
	gint16 *currwav;

	if (doneflag)
		return;

	currwav = wave_height;

	for(i = 0; i < DRAW_X * 2; i += 2 ) {
		*currwav = (data[0][i] >> 10);
		if(*currwav > DRAW_Y)
			*currwav = DRAW_Y;
		else if(*currwav < -(DRAW_Y))
			*currwav = -(DRAW_Y);
		*currwav++ += 36;
	}

	draw_func();
	return;
}
